package wikipediasearch.model
{
	import mx.collections.ArrayCollection;
	import mx.rpc.events.FaultEvent;
	import mx.rpc.events.ResultEvent;
	import mx.rpc.http.HTTPService;
	
	import org.puremvc.as3.interfaces.IProxy;
	import org.puremvc.as3.patterns.proxy.Proxy;
	
	import wikipediasearch.ApplicationFacade;
	
	public class SearchProxy extends Proxy implements IProxy
	{
		public static const NAME:String = "TestProxy";
		
		public function SearchProxy()
		{
			super(NAME);
			results = new ArrayCollection();
		}
		
		public function search(value:String):void
		{
			var service : HTTPService = new HTTPService();
			service.url = "http://api.geonames.org/wikipediaSearch";
			service.method = "GET";
			service.addEventListener(ResultEvent.RESULT, onResult);
			service.addEventListener(FaultEvent.FAULT, onFault);
			
			var params:Object = new Object();
			params.q = value;
			params.maxRows = 10;
			params.username = "oertz";
			service.send(params);
		}
		
		private function onResult(event:ResultEvent):void
		{
			// Initialize results
			results.removeAll();
			
			var xml:XML = new XML(event.message.body);			
			for each (var entry:Object in xml.entry)
			{
				var result:SearchVO = new SearchVO(entry.title,
												   entry.summary,
												   entry.wikipediaUrl,
												   entry.thumbnailImg,
												   entry.lon,
												   entry.lat);
				results.addItem(result);
			}
			
			// Notify view
			facade.sendNotification(ApplicationFacade.WIKI_SEARCH_SUCCESS);
		}
		
		private function onFault(event:FaultEvent):void
		{
			// Notify view
			facade.sendNotification(ApplicationFacade.WIKI_SEARCH_FAULT);
		}
		
		/**
		 * Accessors
		 **/
		public function get results() : ArrayCollection 
		{
			return data as ArrayCollection;
		}
		
		public function set results(value:ArrayCollection) : void
		{
			data = value;
		}
		
	}
}